package w2phtml.rdf;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.stream.events.Namespace;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerFactoryConfigurationError;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.apache.jena.rdf.model.Model;
import org.apache.jena.rdf.model.ModelFactory;
import org.apache.jena.rdf.model.Property;
import org.apache.jena.rdf.model.Resource;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;

import com.sun.org.apache.xml.internal.utils.NameSpace;

import pro.litvinovg.xml.Debug;
import w2phtml.api.ConverterResult;
import w2phtml.api.OutputFile;
import w2phtml.base.ConverterResultImpl;
import w2phtml.xhtml.Converter;
import w2phtml.xhtml.XhtmlDocument;


public final class RDFConverter extends Converter {

   // Constructor
   public RDFConverter() {
       super(XhtmlDocument.HTML5);
       this.isRDF = true;
   }

     @Override public ConverterResult convert(InputStream is, String sTargetFileName) throws IOException {
     	setOpenPubStructure(false);
     	ConverterResult xhtmlResult = super.convert(is, "chapter");
     	return createPackage(xhtmlResult,sTargetFileName);
     }
     
     @Override public ConverterResult convert(org.w3c.dom.Document dom, String sTargetFileName, boolean bDestructive) throws IOException {
     	ConverterResult xhtmlResult = super.convert(dom, "chapter", bDestructive);
     	return createPackage(xhtmlResult,sTargetFileName);    	
     }
     
		private ConverterResult createPackage(ConverterResult xhtmlResult, String sTargetFileName) {
     	ConverterResultImpl rdfConverterResult = new ConverterResultImpl();
     	RDFDocumentResult rdfDocument = new RDFDocumentResult(this.outFiles,sTargetFileName,getXhtmlConfig());
     	rdfConverterResult.addDocument(rdfDocument);
     	return rdfConverterResult;
     }

 }